#include "item.h"
#include "../microcontroller.h"

#include <QJsonArray>

ItemData::ItemData(uint32_t itemIdIn, QString name, int8_t value): name_(name), value_(value), itemId_(itemIdIn)
{

}

QString ItemData::getName() const
{
    return name_;
}

void ItemData::setName(QString name)
{
    name_ = name;
}

int8_t ItemData::getValue() const
{
    return value_;
}

uint32_t ItemData::id() const
{
    return  itemId_;
}


//item

Item::Item(uint32_t itemIdIn, QString name, int8_t value,  QObject *parent): QObject(parent), ItemData (itemIdIn, name, value)
{

}

Item::Item(const ItemData& itemData,  QObject *parent): QObject(parent), ItemData(itemData)
{

}

Item::~Item()
{
}

void Item::setFunction(uint8_t function, bool on)
{
    functionChanged(function, on);
}

void Item::setValue(int8_t value)
{
    value_ = value;
    valueChanged(value_);
}

void Item::informValue(int8_t value)
{
    Item::setValue(value);
}
